
game={}
game.scene= require 'scene.0.main' -- currenty these are all created as local objects.  I don't know what the consequence of that is.



-- call back functions for the game.scenes.

function game.directorydropped(path) if game.scene.directorydropped then game.scene.directorydropped(path) end end --Callback function triggered when a directory is dragged and dropped onto the window.
function game.draw() if game.scene.draw then game.scene.draw() end end --Callback function used to draw on the screen every frame.
function game.errhand(msg, layer) if game.scene.errhand then game.scene.errhand(msg, layer) end end --The error handler, used to display error messages.
function game.filedropped(file) if game.scene.filedropped then game.scene.filedropped(file) end end --Callback function triggered when a file is dragged and dropped onto the window.
function game.focus(focus) if game.scene.focus then game.scene.focus(focus) end end --Callback function triggered when window receives or loses focus.
function game.keypressed(key, scancode, isrepeat) if game.scene.keypressed then game.scene.keypressed(key, scancode, isrepeat) end end --Callback function triggered when a key is pressed.
function game.keyreleased(key, scancode) if game.scene.keyreleased then game.scene.keyreleased(key, scancode) end end --Callback function triggered when a keyboard key is released.
function game.load(arg) if game.scene.load then game.scene.load(arg) end end --This function is called exactly once at the beginning of the game.
function game.lowmemory() if game.scene.lowmemory then game.scene.lowmemory() end end --Callback function triggered when the system is running out of memory on mobile devices.
function game.mousefocus(focus) if game.scene.mousefocus then game.scene.mousefocus(focus) end end --Callback function triggered when window receives or loses mouse focus.
function game.mousemoved(x, y, dx, dy, istouch) if game.scene.mousemoved then game.scene.mousemoved(x, y, dx, dy, istouch) end end --Callback function triggered when the mouse is moved.
function game.mousepressed(x, y, button, istouch) if game.scene.mousepressed then game.scene.mousepressed(x, y, button, istouch) end end --Callback function triggered when a mouse button is pressed.
function game.mousereleased(x, y, button, istouch) if game.scene.mousereleased then game.scene.mousereleased(x, y, button, istouch) end end --Callback function triggered when a mouse button is released.
function game.quit() if game.scene.quit then game.scene.quit() end end --Callback function triggered when the game is closed.
function game.resize(w, h) if game.scene.resize then game.scene.resize(w, h) end end --Called when the window is resized.
--function game.run() if game.scene.run then game.scene.run() end end --The main function, containing the main loop. A sensible default is used when left out.
function game.textedited( text, start, length) if game.scene.textedited then game.scene.textedited( text, start, length) end end --Called when the candidate text for an IME has changed.
function game.textinput(text) if game.scene.textinput then game.scene.textinput(text) end end --Called when text has been entered by the user.
function game.threaderror(thread, errorstr) if game.scene.threaderror then game.scene.threaderror(thread, errorstr) end end --Callback function triggered when a Thread encounters an error.
function game.touchmoved( id, x, y, dx, dy, pressure ) if game.scene.touchmoved then game.scene.touchmoved( id, x, y, dx, dy, pressure ) end end --Callback function triggered when a touch press moves inside the touch screen.
function game.touchpressed( id, x, y, dx, dy, pressure ) if game.scene.touchpressed then game.scene.touchpressed( id, x, y, dx, dy, pressure ) end end --Callback function triggered when the touch screen is touched.
function game.touchreleased(id, x, y, dx, dy, pressure ) if game.scene.touchreleased then game.scene.touchreleased(id, x, y, dx, dy, pressure ) end end --Callback function triggered when the touch screen stops being touched.
function game.update(dt) if game.scene.update then game.scene.update(dt) end end --Callback function used to update the state of the game every frame.
function game.visible(visible) if game.scene.visible then game.scene.visible(visible) end end --Callback function triggered when window is shown or hidden.
function game.wheelmoved(x, y) if game.scene.wheelmoved then game.scene.wheelmoved(x, y) end end --Callback function triggered when the mouse wheel is moved.
function game.gamepadaxis(joystick, axis, value ) if game.scene.gamepadaxis then game.scene.gamepadaxis(joystick, axis, value ) end end --Called when a Joystick's virtual gamepad axis is moved.
function game.gamepadpressed(joystick, button ) if game.scene.gamepadpressed then game.scene.gamepadpressed(joystick, button ) end end --Called when a Joystick's virtual gamepad button is pressed.
function game.gamepadreleased(joystick, button ) if game.scene.gamepadreleased then game.scene.gamepadreleased(joystick, button ) end end --Called when a Joystick's virtual gamepad button is released.
function game.joystickadded(joystick) if game.scene.joystickadded then game.scene.joystickadded(joystick) end end --Called when a Joystick is connected.
function game.joystickaxis(joystick, axis, value ) if game.scene.joystickaxis then game.scene.joystickaxis(joystick, axis, value ) end end --Called when a joystick axis moves.
function game.joystickhat(joystick, hat, direction ) if game.scene.joystickhat then game.scene.joystickhat(joystick, hat, direction ) end end --Called when a joystick hat direction changes.
function game.joystickpressed( joystick, button ) if game.scene.joystickpressed then game.scene.joystickpressed( joystick, button ) end end --Called when a joystick button is pressed.
function game.joystickreleased(joystick, button ) if game.scene.joystickreleased then game.scene.joystickreleased(joystick, button ) end end --Called when a joystick button is released.
function game.joystickremoved(joystick) if game.scene.joystickremoved then game.scene.joystickremoved(joystick) end end --Called when a Joystick is disconnected.

return game