require 'object.controller'
require 'object.stage'

local s = {}--controller.demo
---[[
function s.load()

	local g = 100	
	love.graphics.setBackgroundColor(g,g,g)
	
	local dx = (stage.x - controller.menu.w) / 2

	--CONTROLLER 1
	controller[1] = controller.newController(nil, dx, stage.y)
	controller.menu.load(controller[1])
	
	--CONTROLLER 2
	controller[2] = controller.newController(
		{'w','s','a','d','right','left','space','lshift','up','down','q','e'}, 
		love.graphics.getWidth() - dx - controller.menu.w, stage.y)
	controller.menu.load(controller[2])
	
end

function s.draw()
	controller.menu.draw(controller[1],"PLAYER 1")
	controller.menu.draw(controller[2],"PLAYER 2")
	
	stage.draw()
end

function s.keypressed(key)
	for i = 1, #controller do
		controller.keypressed(controller[i], key)
		controller.menu.keypressed(controller[i], key)
	end
end

function s.keyreleased(key)
	controller.keyreleased(controller[1], key)
	controller.keyreleased(controller[2], key)
end

function s.mousepressed(mx,my,button)
	controller.menu.mousepressed(controller[1], mx, my, button)
	controller.menu.mousepressed(controller[2], mx, my, button)
end
--]]
return s