
local s = {}
local lg = love.graphics

--require 'megaman.sprite sheets.classicMegaManSprites'
require 'object.stage'
require 'animator'

function s.load()
	s.img={}
	s.img[1] = lg.newImage('megaman/sprite sheets/classicMegaManSprites.png')
	
	s.object = {x = stage.x, y = stage.y + stage.h - 260, w = 100, h = 100,
		sx = 10, sy = 10,
		}

	
	s.object.quadTable = animator.createTableOfQuads(s.img[1],50,50)
	animator.giveAnimationProperties(s.object,animator.listOfFrameTables.run)

end

function s.update(dt)
	animator.updateAnimation(s.object,dt)
end

function s.draw()

	local x,y = stage.x, stage.y
	lg.setColor(255,255,255)
	lg.draw(s.img[1], x,y)

	love.graphics.setLineStyle( 'rough'	)
	--love.graphics.setPointStyle("rough")
	animator.drawSprite(s.object, s.img[1])--,img,quadTable)
	
	

end

return s