local trail = {
	timer = 0,
	pulseInterval = 0.01,
	pulseTime = 1,
	pulseRadius = 70,
	dx = 300,
	dy = 40,
	{x=0,y=0,r=0,dx=0,dy=0},
	timer2 = 0,
}

local lg = love.graphics

function trail.update(dt)
	local t = trail
	t.timer = t.timer + dt
	t.timer2 = t.timer2 + dt
	if t.timer > t.pulseInterval then
		local x,y = love.mouse.getPosition()
		y = y + t.dy*math.sin(t.timer2*math.pi * 3)
		t[#t+1] = {x=x, y=y, r=0, dx=0, dy=0}--math.sin(t.timer2*math.pi) }
	
		t.timer = 0
		
	end
	
	---[[
	for i = #t, 1, -1 do
		if t[i].r > t.pulseRadius then table.remove(t,i) end
		t[i].x = t[i].x + t.dx*dt
		t[i].y = t[i].y + 100*dt
		--t[i].dy = t.pulseRadius*math.sin(math.pi*2*t[i].r/t.pulseRadius)
		t[i].r = t[i].r + t.pulseRadius/t.pulseTime * dt
		
	end
	--]]
end

function trail.draw()


	local t = trail
	for i =  1, #t do
		local p = t[i]
		lg.setColor(10,155,100)--,100)
		lg.circle('line',p.x,p.y + p.dy,p.r,6)
		lg.setColor(0,0,0,10)
		--lg.circle('fill',p.x,p.y + p.dy,p.r,4)
	
	end
	
	lg.rectangle('line',0,0,100,100)
	lg.print(#t,100,100)

end


return trail

