local msg = {}
local lg = love.graphics

function msg.load()
	
	msg.fontSize = 50
	msg.font = lg.newFont(msg.fontSize*0.75)
	msg.txt = "press any key to continue!"
	msg.x = lg.getWidth()
	msg.y = lg.getHeight()/2 - msg.fontSize/2
	msg.blink = false
	msg.timer = 0
	msg.blinkInterval = 0.5
	msg.blinkTime = 0.2
	
end

function msg.draw()
	lg.setColor(200,100,50)
	
	lg.setFont(msg.font)
	if msg.blink then lg.printf(msg.txt,0,msg.y,msg.x,'center') end
	--lg.rectangle('line',0,0,msg.x/2,lg.getHeight()/2) -- testing if center
end

function msg.update(dt)
	msg.timer = msg.timer + dt
	if msg.blink == true then
		if msg.timer > msg.blinkInterval then 
			msg.timer = 0
			msg.blink = false
		end
	elseif msg.blink == false then
		if msg.timer > msg.blinkTime then 
			msg.timer = 0
			msg.blink = true
		end
	
	end
end

return msg